
public class Numbers {
	
	private /*@ spec_public @*/ int[] numlist;
	private /*@ spec_public @*/ final int size = 10;
	
	public Numbers() {
		
		numlist = new int[size];
		for(int i = 0 ; i < size; i++) {
			numlist[i] = i;
		}
	}
	
	/*@ public normal_behavior
    @  ensures (\forall int k; 0 <= k && k < size; result >= numlist[k]);
    @*/
	public int getMax() {
		int max = 0;
		int i = 0;
		
	    /*@ loop_invariant
        @	i >= 0 && i < size
        @   && (\forall int k; 0 <= k && k < i; max >= numlist[i])
        @	&& (i == 0 ==> max == 0)
        @	&& (i > 0 ==> (\exists int k; 0 <= k && k < i ; max == numlist[k]));
        @  assignable max, i;
        @  decreases (size - i);
        @*/
		for(i = 0 ; i < size; i++) {
			
			if(numlist[i] > max) {
				max = numlist[i];
			}
		}
		
		return max;
	}
	
}
